unit BB55_ACP;

interface
uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls,
  Dialogs, ExtCtrls, StdCtrls,LPTIO;

 procedure ACP;
 Function convert(bytex:byte):byte;
 Procedure write_port (port_number,output_byte:byte);
 function Write_control_port(port_data:byte):byte;
 Function Read_status_port:byte;
 Procedure write_control(Control_word:byte);
 Procedure LB_toki;
 procedure Zap_mas(sred:byte);
 var
 byt_ap4,byt_BB55,byt_DD2,
 byt_DD3,byt_DD4,byt_DD5:integer;
 byte_1st,byte_2nd:byte;
 datas: array [0..8,1..8] of integer;  //  [ 0...8( A,B,C...),1...8(BYT)]

implementation

uses Glav, skor;



(************************************)
Function convert(bytex:byte):byte;
begin
     convert:=   ((bytex and 1) + ((bytex and 2) shl 1)+
                 ((bytex and 4) shl 2) + (bytex  and 8) shl 3+
                 ((bytex and 16) shr 3) + ((bytex  and 32) shr 2) +
                 (bytex and 64)  shr 1 + ((bytex  and 128)));
end;

(************************************)

(* -----Resource Library No. A5 (Write data to CONTROL port of pc)----- *)
function Write_control_port(port_data:byte):byte;
begin
     if port_data and 1 =1 then port_data:=port_data and (255-1)
        else port_data:=port_data or 1;
     if port_data and 2 =2 then port_data:=port_data and (255-2)
        else port_data:=port_data or 2;
     if port_data and 8 =8 then port_data:=port_data and (255-8)
        else port_data:=port_data or 8;
        Form1.Lpt.WritePort (LPT2,2,port_data);
end;


(************************************)

Procedure write_control(Control_word:byte);
begin
     Control_word:=convert(Control_word);(*Convert the word*)
     Form1.Lpt.WritePort (LPT2,0,Control_word); (*Control word output from port *)
      Write_control_port(2+4+8); (* 2_Write=1, 4_A0=1, 8_A1=1, *)
      Write_control_port(0+4+8); (* 2_Write=0, 4_A0=1, 8_A1=1, *)
      Write_control_port(2+4+8); (* 2_Write=1, 4_A0=1, 8_A1=1, *)
end;

(* -----Resource Library No. A3 (Read data into pc)----- *)
Function Read_status_port:byte;
var
   byte1:byte;
begin
      byte1:=Form1.Lpt.ReadPort(LPT2,1) ;          (* read a byte from the status port *)
      byte1:=byte1 and 120;             (* 01111000 (MSB to LSB) and 0dddd... = 0dddd000 *)
      Read_status_port:=byte1 shr 3;    (* shift 3 bit right, Read_status_port = 0000hhhh *)
end;



(************************************)

Procedure write_port (port_number,output_byte:byte);
begin
      Form1.Lpt.WritePort (LPT2,0,output_byte);  (*Output a byte from port LPT2*)
     if (port_number=0) then begin  (*Output a byte to A register of 8255 *)

        byt_BB55:=2+4+0;
        Write_control_port(byt_ap4+byt_BB55);(* 2_Write=1, 4_A0=1, 8_A1=0*)

        byt_BB55:=0+4+0;
        Write_control_port(byt_ap4+byt_BB55);(* 2-Write=0, 4_A0=1, 8_A1=0*)

        byt_BB55:=2+4+0;
        Write_control_port(byt_ap4+byt_BB55);(* 2_Write=1, 4_A0=1, 8_A1=0*)
              end;
     if (port_number=1) then begin  (*Output a byte to B register of 8255 *)

           byt_BB55:=2+0+0;
        Write_control_port(byt_ap4+byt_BB55);(* Write=1, A0=0, A1=0*)

           byt_BB55:=0+0+0;
        Write_control_port(byt_ap4+byt_BB55);(* Write=0, A0=0, A1=0*)

           byt_BB55:=2+0+0;
        Write_control_port(byt_ap4+byt_BB55);(* Write=1, A0=0, A1=0*)
                     end;
     if (port_number=2) then begin  (*Output a byte to C register of 8255 *)

           byt_BB55:=2+0+8;
        Write_control_port(byt_ap4+byt_BB55);(* Write=1, A0=0, A1=1*)

           byt_BB55:=0+0+8;
        Write_control_port(byt_ap4+byt_BB55);(* Write=0, A0=0, A1=1*)

           byt_BB55:=2+0+8;
        Write_control_port(byt_ap4+byt_BB55);(* Write=1, A0=0, A1=1*)
                      end;
end;


(************************************)

Function Inputbyte(port_number:byte):integer;
begin
     if (port_number=0) then
     begin                   (*Read a byte from port A of 8255*)

        byt_DD3:=128+0+0;
    Write_Port(1,byt_DD2+byt_DD3); (* DD3 * 128_Rd=1, 32_A0=0, 8_A1=0*)

        byt_DD3:=0+0+0;
    Write_Port(1,byt_DD2+byt_DD3);  (* DD3 * 128_Rd=0, 32_A0=0, 8_A1=0*)

      (*****************************)
        byt_ap4:=0;
    Write_control_port(byt_ap4+byt_BB55);

        byt_DD2:=2+0+0;
    Write_Port(1,byt_DD2+byt_DD3);   (* DD2* 2_Rd=1, 64_A0=0, 16_A1=0*)

        byt_DD2:=0+0+0;
    Write_Port (1,byt_DD2+byt_DD3);  (* DD2* 2_Rd=0, 64_A0=0, 16_A1=0*)

        byte_2nd:= Read_status_port ;
        byt_ap4:=1;

    Write_control_port(byt_ap4+byt_BB55);
        byte_1st:= Read_status_port;   (*Read high 4 bits*)

        byt_DD2:=2+0+0;
    Write_Port (1,byt_DD2+byt_DD3);   (* DD2* 2_Rd=1, 64_A0=0, 16_A1=0*)

   (*----------------------------------------*)
        byt_DD3:=128+0+0;
    Write_Port (1,byt_DD2+byt_DD3);   (* DD3 * 128_Rd=1, 32_A0=0, 8_A1=0*)
            end;

{*******************************************}
     if (port_number=1) then          (*Read a byte from port B of DD3*)
     begin
       byt_DD3:=128+32+0;     (* DD3 * 128_Rd=1, 32_A0=1, 8_A1=0*)
       write_port(1,byt_DD2+byt_DD3);

       byt_DD3:=0+32+0;   (* DD3* 128_Rd=0, 32_A0=1, 8_A1=0*)
       write_port(1,byt_DD2+byt_DD3);
   (*----------------------------------------*)
       byt_ap4:=0;  (*  DD5  *) (* read low 4 bits*)
       Write_control_port(byt_ap4+byt_BB55);

       byt_DD2:=2+0+0;   (* DD2* 2_Rd=1, 64_A0=0, 16_A1=0*)
       write_port(1,byt_DD2+byt_DD3);

       byt_DD2:=0+0+0;    (* DD2* 2_Rd=0, 64_A0=0, 16_A1=0*)
       write_port(1,byt_DD2+byt_DD3);

       byte_2nd:=Read_status_port;       (*Read low 4 bits*)
       byt_ap4:=1;

       Write_control_port(byt_ap4+byt_BB55);
       byte_1st:= Read_status_port;   (*Read high 4 bits*)

       byt_DD2:=2+0+0;   (* DD2* 2_Rd=1, 64_A0=0, 16_A1=0*)
       write_port(1,byt_DD2+byt_DD3);
   (*----------------------------------------*)
       byt_DD3:=128+32+0; (* DD3* 128_Rd=1, 32_A0=1, 8_A1=0*)
       write_port(1,byt_DD2+byt_DD3);
     end;

     {*******************************************}

     if (port_number=2) then          (*Read a byte from port C of DD3*)
     begin
       byt_DD3:=128+0+8;     (* DD3 * 128_Rd=1, 32_A0=0, 8_A1=1*)
       write_port(1,byt_DD2+byt_DD3);

       byt_DD3:=0+0+8;   (* DD3* 128_Rd=0, 32_A0=0, 8_A1=1*)
       write_port(1,byt_DD2+byt_DD3);
   (*----------------------------------------*)

       byt_ap4:=0;  (*  DD5  *) (* read low 4 bits*)
       Write_control_port(byt_ap4+byt_BB55);

       byt_DD2:=2+0+0;   (* DD2* 2_Rd=1, 64_A0=0, 16_A1=0*)
       write_port(1,byt_DD2+byt_DD3);

       byt_DD2:=0+0+0;    (* DD2* 2_Rd=0, 64_A0=0, 16_A1=0*)
       write_port(1,byt_DD2+byt_DD3);

       byte_2nd:=Read_status_port;       (*Read low 4 bits*)
       byt_ap4:=1;

       Write_control_port(byt_ap4+byt_BB55);
       byte_1st:= Read_status_port;   (*Read high 4 bits*)

       byt_DD2:=2+0+0;   (* DD2* 2_Rd=1, 64_A0=0, 16_A1=0*)
       write_port(1,byt_DD2+byt_DD3);
   (*----------------------------------------*)

       byt_DD3:=128+0+8; (* DD3* 128_Rd=1, 32_A0=0, 8_A1=0*)
       write_port(1,byt_DD2+byt_DD3);
     end;

     (**************************************)

  if (port_number=3) then
     begin                   (*Read a byte from port D of DD4*)

        byt_DD4:=128+0+0;
    Write_Port(2,byt_DD5+byt_DD4); (* DD4 * 128_Rd=1, 32_A0=0, 8_A1=0*)

        byt_DD4:=0+0+0;
    Write_Port(2,byt_DD5+byt_DD4);  (* DD3 * 128_Rd=0, 32_A0=0, 8_A1=0*)

   (*----------------------------------------*)

       byt_ap4:=0;  (*  DD5  *) (* read low 4 bits*)
       Write_control_port(byt_ap4+byt_BB55);

       byt_DD2:=2+0+16;   (* DD2* 2_Rd=1, 64_A0=0, 16_A1=1*)
       write_port(1,byt_DD2+byt_DD3);

       byt_DD2:=0+0+16;    (* DD2* 2_Rd=0, 64_A0=0, 16_A1=1*)
       write_port(1,byt_DD2+byt_DD3);

       byte_2nd:=Read_status_port;       (*Read low 4 bits*)
       byt_ap4:=1;

       Write_control_port(byt_ap4+byt_BB55);
       byte_1st:= Read_status_port;   (*Read high 4 bits*)

       byt_DD2:=2+0+16;   (* DD2* 2_Rd=1, 64_A0=0, 16_A1=1*)
       write_port(1,byt_DD2+byt_DD3);

   (*---------------------------------------*)
        byt_DD4:=128+0+0;
    Write_Port (2,byt_DD4+byt_DD5);   (* DD3 * 128_Rd=1, 32_A0=1, 8_A1=0*)
            end;

{*******************************************}
     if (port_number=4) then          (*Read a byte from port E of DD4*)
     begin
       byt_DD4:=128+32+0;     (* DD3 * 128_Rd=1, 32_A0=1, 8_A1=0*)
       write_port(2,byt_DD5+byt_DD5);

       byt_DD4:=0+32+0;   (* DD4* 128_Rd=0, 32_A0=1, 8_A1=0*)
       write_port(2,byt_DD4+byt_DD5);
    (*----------------------------------------*)

       byt_ap4:=0;  (*  DD5  *) (* read low 4 bits*)
       Write_control_port(byt_ap4+byt_BB55);

       byt_DD2:=2+0+16;   (* DD2* 2_Rd=1, 64_A0=0, 16_A1=1*)
       write_port(1,byt_DD2+byt_DD3);

       byt_DD2:=0+0+16;    (* DD2* 2_Rd=0, 64_A0=0, 16_A1=1*)
       write_port(1,byt_DD2+byt_DD3);

       byte_2nd:=Read_status_port;       (*Read low 4 bits*)
       byt_ap4:=1;

       Write_control_port(byt_ap4+byt_BB55);
       byte_1st:= Read_status_port;   (*Read high 4 bits*)

       byt_DD2:=2+0+16;   (* DD2* 2_Rd=1, 64_A0=0, 16_A1=1*)
       write_port(1,byt_DD2+byt_DD3);

   (*---------------------------------------*)
       byt_DD4:=128+32+0;  (* DD4* 128_Rd=1, 32_A0=1, 8_A1=0*)
       write_port(2,byt_DD4+byt_DD5);
     end;

  {*******************************************}

     if (port_number=5) then          (*Read a byte from port F of DD4*)
     begin
       byt_DD4:=128+0+8;     (* DD4 * 128_Rd=1, 32_A0=0, 8_A1=1*)
      write_port(2,byt_DD4+byt_DD5);

       byt_DD4:=0+0+8;   (* DD4* 128_Rd=0, 32_A0=0, 8_A1=1*)
      write_port(2,byt_DD4+byt_DD5);
   (*----------------------------------------*)

       byt_ap4:=0;  (*  DD5  *) (* read low 4 bits*)
       Write_control_port(byt_ap4+byt_BB55);

       byt_DD2:=2+0+16;   (* DD2* 2_Rd=1, 64_A0=0, 16_A1=1*)
       write_port(1,byt_DD2+byt_DD3);

       byt_DD2:=0+0+16;    (* DD2* 2_Rd=0, 64_A0=0, 16_A1=1*)
       write_port(1,byt_DD2+byt_DD3);

       byte_2nd:=Read_status_port;       (*Read low 4 bits*)
       byt_ap4:=1;

       Write_control_port(byt_ap4+byt_BB55);
       byte_1st:= Read_status_port;   (*Read high 4 bits*)

       byt_DD2:=2+0+16;   (* DD2* 2_Rd=1, 64_A0=0, 16_A1=1*)
       write_port(1,byt_DD2+byt_DD3);

   (*---------------------------------------*)

       byt_DD4:=128+0+8; (* DD4* 128_Rd=1, 32_A0=0, 8_A1=0*)
    write_port(2,byt_DD4+byt_DD5);
     end;
{*******************************************}

  if (port_number=6) then
     begin                   (*Read a byte from port G of DD4*)

        byt_DD4:=2+0+0;
    Write_Port(2,byt_DD5+byt_DD4); (* DD4 * 2_Rd=1, 1_A0=0, 4_A1=0*)

        byt_DD4:=0+0+0;
    Write_Port(2,byt_DD5+byt_DD4);  (* DD3 * 2_Rd=0, 1_A0=0, 4_A1=0*)

   (*----------------------------------------*)

       byt_ap4:=0;  (*  DD5  *) (* read low 4 bits*)
       Write_control_port(byt_ap4+byt_BB55);

       byt_DD2:=2+64+0;   (* DD2* 2_Rd=1, 64_A0=1, 16_A1=0*)
       write_port(1,byt_DD2+byt_DD3);

       byt_DD2:=0+64+0;    (* DD2* 2_Rd=0, 64_A0=1, 16_A1=0*)
       write_port(1,byt_DD2+byt_DD3);

       byte_2nd:=Read_status_port;       (*Read low 4 bits*)
       byt_ap4:=1;

       Write_control_port(byt_ap4+byt_BB55);
       byte_1st:= Read_status_port;   (*Read high 4 bits*)

       byt_DD2:=2+64+0;   (* DD2* 2_Rd=1, 64_A0=1, 16_A1=0*)
       write_port(1,byt_DD2+byt_DD3);

   (*---------------------------------------*)
       byt_DD4:=2+0+0;
       Write_Port (2,byt_DD4+byt_DD5);   (* DD3 * 2_Rd=1, 1_A0=1, 4_A1=0*)
            end;

{*******************************************}
     if (port_number=7) then          (*Read a byte from port H of DD4*)
     begin
       byt_DD4:=2+1+0;     (* DD3 * 2_Rd=1, 1_A0=1, 4_A1=0*)
       write_port(2,byt_DD5+byt_DD5);

       byt_DD4:=0+1+0;   (* DD4* 2_Rd=0, 1_A0=1, 4_A1=0*)
       write_port(2,byt_DD4+byt_DD5);
    (*----------------------------------------*)

       byt_ap4:=0;  (*  DD5  *) (* read low 4 bits*)
       Write_control_port(byt_ap4+byt_BB55);

       byt_DD2:=2+64+0;   (* DD2* 2_Rd=1, 64_A0=0, 16_A1=1*)
       write_port(1,byt_DD2+byt_DD3);

       byt_DD2:=0+64+0;    (* DD2* 2_Rd=0, 64_A0=0, 16_A1=1*)
       write_port(1,byt_DD2+byt_DD3);

       byte_2nd:=Read_status_port;       (*Read low 4 bits*)
       byt_ap4:=1;

       Write_control_port(byt_ap4+byt_BB55);
       byte_1st:= Read_status_port;   (*Read high 4 bits*)

       byt_DD2:=2+64+0;   (* DD2* 2_Rd=1, 64_A0=0, 16_A1=1*)
       write_port(1,byt_DD2+byt_DD3);

   (*---------------------------------------*)
       byt_DD4:=2+1+0;  (* DD4* 2_Rd=1, 1_A0=1, 4_A1=0*)
       write_port(2,byt_DD4+byt_DD5);
     end;

  {*******************************************}

     if (port_number=8) then          (*Read a byte from port R of DD4*)
     begin
       byt_DD4:=2+0+4;     (* DD4 * 2_Rd=1, 1_A0=0, 4_A1=1*)
       write_port(2,byt_DD4+byt_DD5);

       byt_DD4:=0+0+4;   (* DD4* 2_Rd=0, 1_A0=0, 4_A1=1*)
       write_port(2,byt_DD4+byt_DD5);
   (*----------------------------------------*)

       byt_ap4:=0;  (*  DD5  *) (* read low 4 bits*)
       Write_control_port(byt_ap4+byt_BB55);

       byt_DD2:=2+64+0;   (* DD2* 2_Rd=1, 64_A0=0, 16_A1=1*)
       write_port(1,byt_DD2+byt_DD3);

       byt_DD2:=0+64+0;    (* DD2* 2_Rd=0, 64_A0=0, 16_A1=1*)
       write_port(1,byt_DD2+byt_DD3);

       byte_2nd:=Read_status_port;       (*Read low 4 bits*)
       byt_ap4:=1;

       Write_control_port(byt_ap4+byt_BB55);
       byte_1st:= Read_status_port;   (*Read high 4 bits*)

       byt_DD2:=2+64+0;   (* DD2* 2_Rd=1, 64_A0=0, 16_A1=1*)
       write_port(1,byt_DD2+byt_DD3);

   (*---------------------------------------*)

       byt_DD4:=2+0+4; (* DD4* 2_Rd=1, 1_A0=0, 4_A1=0*)
       write_port(2,byt_DD4+byt_DD5);
     end;
{*******************************************}

        Inputbyte:=byte_1st*16+byte_2nd;
end;
(************************************)
procedure ACP;
 var
   k1,i1,j1,tempInt,mask:integer;

begin
(***********  ACP  ***********************)
     (*---------    ----------*)
     Write_port(0, 0+32); (* Clock=0, -CS=1 *)
     write_port(0, 0+0); (* Clock=0, -CS=0 *)


     for k1:=0 to 8 do
      begin
       for j1:=1 to 8 do
        begin
           datas[k1,j1]:=0;
        end;
      end;
     (* ------    --------- *)
     for i1:=1 to 10 do
      begin
       for k1:=0 to 8 do
        begin
          mask:=1;
          tempInt:=(Inputbyte(k1));
           for j1:=1 to 8 do
             begin
               datas[k1,j1]:=datas[k1,j1]*2+((tempInt and mask) div mask);
               mask:=mask*2;
            end;
        end;
     (*--     -----*)
       write_port(0, 0+0);   (* Clock=0, -CS=0 *)
       write_port(0, 128+0); (* Clock=1, -CS=0 *)
       write_port(0, 0+0);   (* Clock=0, -CS=0 *)
     end;
  end;

(**********************************)
procedure Zap_mas(sred:byte);
  var k1,j1,i1,dat_temp:integer;
   dat: array [0..8,1..8] of integer;  //  [ 0...255)
begin
 for k1:=0 to 8 do
       begin
         for j1:=1 to 8 do
          begin
            dat[k1,j1]:=0;

          end;
        end;

 (*-------------------------------*)

 for i1:= 1 to sred do
  begin
  ACP;

     for k1:=0 to 8 do
       begin
         for j1:=1 to 8 do
          begin
            dat[k1,j1]:= dat[k1,j1]+datas[k1,j1];      //  [ 0...8( A,B,C...),1...8(BYT)]

          end;
        end;
   end;

(*-------------------------------*)
     for k1:=0 to 8 do
      begin
       for j1:=1 to 8 do
        begin

         try
          MasTV[k1*8+j1,i].Tok := round(dat[k1,j1]/sred);      //  [ 0...8( A,B,C...),1...8(BYT)]
        except
         SrdArefm:=5;
         sred:=5;
         skorost.MaskEdit7.Text:=intToStr(5); 
         ShowMessage('   : ');
            exit;
         end;
          MasTV[k1*8+j1,i].Vremya := Now;
        end;
      end;
  end;

 (**********************************)
 Procedure LB_toki;
 begin
  (*------------------ A --------------------*)
 Form1.Lb_Tok1.Caption:=intToStr(round(MasTV[1,i].Tok));
 Form1.Lb_Tok2.Caption:=intToStr(round(MasTV[2,i].Tok));
 Form1.Lb_Tok3.Caption:=intToStr(round(MasTV[3,i].Tok));
 Form1.Lb_Tok4.Caption:=intToStr(round(MasTV[4,i].Tok));
 Form1.Lb_Tok5.Caption:=intToStr(round(MasTV[5,i].Tok));
 Form1.Lb_Tok6.Caption:=intToStr(round(MasTV[6,i].Tok));
 Form1.Lb_Tok7.Caption:=intToStr(round(MasTV[7,i].Tok));
 Form1.Lb_Tok8.Caption:=intToStr(round(MasTV[8,i].Tok));
   (*------------------ B --------------------*)
 Form1.Lb_Tok9.Caption:=intToStr(round(MasTV[9,i].Tok));
 Form1.Lb_Tok10.Caption:=intToStr(round(MasTV[10,i].Tok));
 Form1.Lb_Tok11.Caption:=intToStr(round(MasTV[11,i].Tok));
 Form1.Lb_Tok12.Caption:=intToStr(round(MasTV[12,i].Tok));
 Form1.Lb_Tok13.Caption:=intToStr(round(MasTV[13,i].Tok));
 Form1.Lb_Tok14.Caption:=intToStr(round(MasTV[14,i].Tok));
 Form1.Lb_Tok15.Caption:=intToStr(round(MasTV[15,i].Tok));
 Form1.Lb_Tok16.Caption:=intToStr(round(MasTV[16,i].Tok));
   (*------------------ C --------------------*)
 Form1.Lb_Tok17.Caption:=intToStr(round(MasTV[17,i].Tok));
 Form1.Lb_Tok18.Caption:=intToStr(round(MasTV[18,i].Tok));
 Form1.Lb_Tok19.Caption:=intToStr(round(MasTV[19,i].Tok));
 Form1.Lb_Tok20.Caption:=intToStr(round(MasTV[20,i].Tok));
 Form1.Lb_Tok21.Caption:=intToStr(round(MasTV[21,i].Tok));
 Form1.Lb_Tok22.Caption:=intToStr(round(MasTV[22,i].Tok));
 Form1.Lb_Tok23.Caption:=intToStr(round(MasTV[23,i].Tok));
 Form1.Lb_Tok24.Caption:=intToStr(round(MasTV[24,i].Tok));
 (*------------------ D --------------------*)
 Form1.Lb_Tok25.Caption:=intToStr(round(MasTV[25,i].Tok));
 Form1.Lb_Tok26.Caption:=intToStr(round(MasTV[26,i].Tok));
 Form1.Lb_Tok27.Caption:=intToStr(round(MasTV[27,i].Tok));
 Form1.Lb_Tok28.Caption:=intToStr(round(MasTV[28,i].Tok));
 Form1.Lb_Tok29.Caption:=intToStr(round(MasTV[29,i].Tok));
 Form1.Lb_Tok30.Caption:=intToStr(round(MasTV[30,i].Tok));
 Form1.Lb_Tok31.Caption:=intToStr(round(MasTV[31,i].Tok));
 Form1.Lb_Tok32.Caption:=intToStr(round(MasTV[32,i].Tok));
   (*------------------ E --------------------*)
 Form1.Lb_Tok33.Caption:=intToStr(round(MasTV[33,i].Tok));
 Form1.Lb_Tok34.Caption:=intToStr(round(MasTV[34,i].Tok));
 Form1.Lb_Tok35.Caption:=intToStr(round(MasTV[35,i].Tok));
 Form1.Lb_Tok36.Caption:=intToStr(round(MasTV[36,i].Tok));
 Form1.Lb_Tok37.Caption:=intToStr(round(MasTV[37,i].Tok));
 Form1.Lb_Tok38.Caption:=intToStr(round(MasTV[38,i].Tok));
 Form1.Lb_Tok39.Caption:=intToStr(round(MasTV[39,i].Tok));
 Form1.Lb_Tok40.Caption:=intToStr(round(MasTV[40,i].Tok));
   (*------------------ F --------------------*)
 Form1.Lb_Tok41.Caption:=intToStr(round(MasTV[41,i].Tok));
 Form1.Lb_Tok42.Caption:=intToStr(round(MasTV[42,i].Tok));
 Form1.Lb_Tok43.Caption:=intToStr(round(MasTV[43,i].Tok));
 Form1.Lb_Tok44.Caption:=intToStr(round(MasTV[44,i].Tok));
 Form1.Lb_Tok45.Caption:=intToStr(round(MasTV[45,i].Tok));
 Form1.Lb_Tok46.Caption:=intToStr(round(MasTV[46,i].Tok));
 Form1.Lb_Tok47.Caption:=intToStr(round(MasTV[47,i].Tok));
 Form1.Lb_Tok48.Caption:=intToStr(round(MasTV[48,i].Tok));
   (*------------------ G -------------------*)
 Form1.Lb_Tok49.Caption:=intToStr(round(MasTV[49,i].Tok));
 Form1.Lb_Tok50.Caption:=intToStr(round(MasTV[50,i].Tok));
 Form1.Lb_Tok51.Caption:=intToStr(round(MasTV[51,i].Tok));
 Form1.Lb_Tok52.Caption:=intToStr(round(MasTV[52,i].Tok));
 Form1.Lb_Tok53.Caption:=intToStr(round(MasTV[53,i].Tok));
 Form1.Lb_Tok54.Caption:=intToStr(round(MasTV[54,i].Tok));
 Form1.Lb_Tok55.Caption:=intToStr(round(MasTV[55,i].Tok));
 Form1.Lb_Tok56.Caption:=intToStr(round(MasTV[56,i].Tok));
   (*------------------ H --------------------*)
 Form1.Lb_Tok57.Caption:=intToStr(round(MasTV[57,i].Tok));
 Form1.Lb_Tok58.Caption:=intToStr(round(MasTV[58,i].Tok));
 Form1.Lb_Tok59.Caption:=intToStr(round(MasTV[59,i].Tok));
 Form1.Lb_Tok60.Caption:=intToStr(round(MasTV[60,i].Tok));
 Form1.Lb_Tok61.Caption:=intToStr(round(MasTV[61,i].Tok));
 Form1.Lb_Tok62.Caption:=intToStr(round(MasTV[62,i].Tok));
 Form1.Lb_Tok63.Caption:=intToStr(round(MasTV[63,i].Tok));
 Form1.Lb_Tok64.Caption:=intToStr(round(MasTV[64,i].Tok));
   (*------------------ R --------------------*)
 Form1.Lb_Tok65.Caption:=intToStr(round(MasTV[65,i].Tok));
 Form1.Lb_Tok66.Caption:=intToStr(round(MasTV[66,i].Tok));
 Form1.Lb_Tok67.Caption:=intToStr(round(MasTV[67,i].Tok));
 Form1.Lb_Tok68.Caption:=intToStr(round(MasTV[68,i].Tok));
 Form1.Lb_Tok69.Caption:=intToStr(round(MasTV[69,i].Tok));
 Form1.Lb_Tok70.Caption:=intToStr(round(MasTV[70,i].Tok));
 Form1.Lb_Tok71.Caption:=intToStr(round(MasTV[71,i].Tok));
 Form1.Lb_Tok72.Caption:=intToStr(round(MasTV[72,i].Tok));

 end;



end.
